--------------------------------------------------------------------------------
-- From Deriving to SYB
--------------------------------------------------------------------------------

{-# LANGUAGE GADTs                  #-}
{-# LANGUAGE FlexibleContexts       #-}
{-# LANGUAGE FlexibleInstances      #-}
{-# LANGUAGE RankNTypes             #-}
{-# LANGUAGE UndecidableInstances   #-}
{-# LANGUAGE KindSignatures         #-}
{-# LANGUAGE DataKinds              #-}
{-# LANGUAGE MultiParamTypeClasses  #-}
{-# LANGUAGE ScopedTypeVariables    #-}
{-# LANGUAGE OverlappingInstances   #-}

module Test.D2S where

import qualified Test.Deriving as D
import qualified Library.SYB   as S
import Conversion.D2S


--------------------------------------------------------------------------------
-- Tests
--------------------------------------------------------------------------------

d2s1 = S.glength [1,2,3::Int]
d2s2 = S.gsize   [1,2,3::Int]
d2s3 = S.gdepth  [1,2,3::Int]

d2s4 = S.glength (D.RTree (1::Int) [D.RTree 2 [], D.RTree 3 []])
d2s5 = S.gsize   (D.RTree (1::Int) [D.RTree 2 [], D.RTree 3 []])
d2s6 = S.gdepth  (D.RTree (1::Int) [D.RTree 2 [], D.RTree 3 []])

d2s7 = S.everywhere (S.mkT (\n -> n+1::Int)) [1,2,3::Int]
d2s8 = S.everything (++) ("" `S.mkQ` (show :: Int -> String)) [1,2,3::Int]
